<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleAvailRQCoreTypeSpecialEquipPref ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfVehicleAvailRQCoreTypeSpecialEquipPref extends AbstractStructArrayBase
{
    /**
     * The SpecialEquipPref
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref[]
     */
    public $SpecialEquipPref;
    /**
     * Constructor method for ArrayOfVehicleAvailRQCoreTypeSpecialEquipPref
     * @uses DgArrayOfVehicleAvailRQCoreTypeSpecialEquipPref::setSpecialEquipPref()
     * @param \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref[] $specialEquipPref
     */
    public function __construct(array $specialEquipPref = array())
    {
        $this
            ->setSpecialEquipPref($specialEquipPref);
    }
    /**
     * Get SpecialEquipPref value
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref[]|null
     */
    public function getSpecialEquipPref()
    {
        return $this->SpecialEquipPref;
    }
    /**
     * Set SpecialEquipPref value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref[] $specialEquipPref
     * @return \dgsoft\ArrayType\DgArrayOfVehicleAvailRQCoreTypeSpecialEquipPref
     */
    public function setSpecialEquipPref(array $specialEquipPref = array())
    {
        foreach ($specialEquipPref as $arrayOfVehicleAvailRQCoreTypeSpecialEquipPrefSpecialEquipPrefItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleAvailRQCoreTypeSpecialEquipPrefSpecialEquipPrefItem instanceof \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref) {
                throw new \InvalidArgumentException(sprintf('The SpecialEquipPref property can only contain items of \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref, "%s" given', is_object($arrayOfVehicleAvailRQCoreTypeSpecialEquipPrefSpecialEquipPrefItem) ? get_class($arrayOfVehicleAvailRQCoreTypeSpecialEquipPrefSpecialEquipPrefItem) : gettype($arrayOfVehicleAvailRQCoreTypeSpecialEquipPrefSpecialEquipPrefItem)), __LINE__);
            }
        }
        $this->SpecialEquipPref = $specialEquipPref;
        return $this;
    }
    /**
     * Add item to SpecialEquipPref value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref $item
     * @return \dgsoft\ArrayType\DgArrayOfVehicleAvailRQCoreTypeSpecialEquipPref
     */
    public function addToSpecialEquipPref(\dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref) {
            throw new \InvalidArgumentException(sprintf('The SpecialEquipPref property can only contain items of \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SpecialEquipPref[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeSpecialEquipPref|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SpecialEquipPref
     */
    public function getAttributeName()
    {
        return 'SpecialEquipPref';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfVehicleAvailRQCoreTypeSpecialEquipPref
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
